﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CreateSkeleton
{
    public class EnumDef
    {
        public string name { get; set; }
        public string source_file { get; set; }
        public string primitive_type { get; set; }
        public Dictionary<string, string> members { get; set; }
    }

    public class UnionDef
    {
        public string name { get; set; }
        public string source_file { get; set; }
        public List<string> members { get; set; }
    }

    public class StructDef
    {
        public string name { get; set; }
        public string source_file { get; set; }
        public List<string> members { get; set; }
    }

    public class TypeDef
    {
        public string name { get; set; }
        public string source_file { get; set; }
        public string definition { get; set; }
    }

    public class LabelDef
    {
        public string name { get; set; }
        public string offset_dec { get; set; }
        public string offset_hex { get; set; }
    }

    public class ExternalDeclarationDef
    {
        public string source_file { get; set; }
        public string declaration { get; set; }
    }

    public class BlockDef
    {
        public string source_file { get; set; }
        public string start_line { get; set; }
        public string end_line { get; set; }
        public string start_offset { get; set; }
        public string end_offset { get; set; }
        //public List<TypeDef> typedefs { get; set; }
        public List<string> typedefs { get; set; }
        public List<string> variables { get; set; }
        public List<LabelDef> labels { get; set; }
        public List<BlockDef> sub_blocks { get; set; }
    }

    public class FunctionDef
    {
        public string name { get; set; }
        public string source_file { get; set; }
        public string source_file_line_number { get; set; }
        public string offset_dec { get; set; }
        public string offset_hex { get; set; }
        public string stack_frame_base { get; set; }
        public string stack_frame_size_dec { get; set; }
        public string stack_frame_size_hex { get; set; }
        public string mask_offset_dec { get; set; }
        public string mask_offset_hex { get; set; }
        public List<string> saved_registers { get; set; }
        public string method_signature { get; set; }
        public List<BlockDef> blocks { get; set; }
    }

    public class SymDumpJSON
    {
        public int Version { get; set; }
        public int targetUnit { get; set; }
        public List<EnumDef> enums { get; set; }
        public List<UnionDef> unions { get; set; }
        public List<StructDef> structs { get; set; }
        public List<LabelDef> labels { get; set; }
        public List<ExternalDeclarationDef> external_declarations { get; set; }
        public List<FunctionDef> functions { get; set; }

    }
}
