﻿// PlayStation ELF Converter
// Converts between ELF and PSX-EXE executable formats
// Copyright 2019 Ben Lincoln
// https://www.beneaththewaves.net/
// Based in part on information documented in LameGuy64's elf2x utility
// (http://www.psxdev.net/forum/viewtopic.php?f=75&t=1613)

// This file is part of PlayStation ELF Converter.

// PlayStation ELF Converter is free software: you can redistribute it and/or modify
// it under the terms of version 3 of the GNU General Public License as published by
// the Free Software Foundation.

// PlayStation ELF Converter is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with PlayStation ELF Converter (in the file LICENSE.txt).  
// If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BenLincoln.ExecutableFiles
{
    public class BinaryFile
    {
        protected string _FileTypeName;



        #region Properties

        public string FileTypeName
        {
            get
            {
                return _FileTypeName;
            }
        }

        #endregion

        public BinaryFile()
        {
            _FileTypeName = "Unknown";
        }

        public virtual void ReadFile(BinaryReader binaryReader)
        {
            
        }

        public virtual void WriteFile(BinaryWriter outputWriter)
        {
            
        }

        public virtual string GetFileInfoString()
        {
            return String.Format("File type: {0}", FileTypeName);
        }

    }
}
